% Lexikon von Artikeln und Pronomen

det([indef],[mask,sg,nom]) --> [ein].
det([def],  [mask,sg,nom]) --> [der].
det([qu],   [mask,sg,nom]) --> [welcher].
det([all],  [mask,sg,nom]) --> [jeder].

det([indef],[mask,sg,gen]) --> [eines].
det([def],  [mask,sg,gen]) --> [des].
det([qu],   [mask,sg,gen]) --> [welches].
det([all],  [mask,sg,gen]) --> [jedes].

det([indef],[mask,sg,dat]) --> [einem].
det([def],  [mask,sg,dat]) --> [dem].
det([qu],   [mask,sg,dat]) --> [welchem].
det([all],  [mask,sg,dat]) --> [jedem].

det([indef],[mask,sg,akk]) --> [einen].
det([def],  [mask,sg,akk]) --> [den].
det([qu],   [mask,sg,akk]) --> [welchen].
det([all],  [mask,sg,akk]) --> [jeden].

det([indef],[fem, sg,nom]) --> [eine].
det([def],  [fem, sg,nom]) --> [die].
det([qu],   [fem, sg,nom]) --> [welche].
det([all],  [fem, sg,nom]) --> [jede].

det([indef],[fem, sg,gen]) --> [einer].
det([def],  [fem, sg,gen]) --> [der].
det([qu],   [fem, sg,gen]) --> [welcher].
det([all],  [fem, sg,gen]) --> [jeder].

det([indef],[fem, sg,dat]) --> [einer].
det([def],  [fem, sg,dat]) --> [der].
det([qu],   [fem, sg,dat]) --> [welcher].
det([all],  [fem, sg,dat]) --> [jeder].

det([indef],[fem, sg,akk]) --> [eine].
det([def],  [fem, sg,akk]) --> [die].
det([qu],   [fem, sg,akk]) --> [welche].
det([all],  [fem, sg,akk]) --> [jede].

det([indef],[mask,pl,nom]) --> [einige].
det([def],  [mask,pl,nom]) --> [die].
det([qu],   [mask,pl,nom]) --> [welche].
det([all],  [mask,pl,nom]) --> [alle].

det([indef],[mask,pl,gen]) --> [einiger].
det([def],  [mask,pl,gen]) --> [der].
det([qu],   [mask,pl,gen]) --> [welcher].
det([all],  [mask,pl,gen]) --> [aller].

det([indef],[mask,pl,dat]) --> [einigen].
det([def],  [mask,pl,dat]) --> [den].
det([qu],   [mask,pl,dat]) --> [welchen].
det([all],  [mask,pl,dat]) --> [allen].

det([indef],[mask,pl,akk]) --> [einige].
det([def],  [mask,pl,akk]) --> [die].
det([qu],   [mask,pl,akk]) --> [welche].
det([all],  [mask,pl,akk]) --> [alle].

det([indef],[fem, pl,nom]) --> [einige].
det([def],  [fem, pl,nom]) --> [die].
det([qu],   [fem, pl,nom]) --> [welche].
det([all],  [fem, pl,nom]) --> [alle].

det([indef],[fem, pl,gen]) --> [einiger].
det([def],  [fem, pl,gen]) --> [der].
det([qu],   [fem, pl,gen]) --> [welcher].
det([all],  [fem, pl,gen]) --> [aller].

det([indef],[fem, pl,dat]) --> [einigen].
det([def],  [fem, pl,dat]) --> [den].
det([qu],   [fem, pl,dat]) --> [welchen].
det([all],  [fem, pl,dat]) --> [allen].

det([indef],[fem, pl,akk]) --> [einige].
det([def],  [fem, pl,akk]) --> [die].
det([qu],   [fem, pl,akk]) --> [welche].
det([all],  [fem, pl,akk]) --> [alle].

det([most], [mask,pl,nom]) --> [die],[meisten].
det([most], [mask,pl,akk]) --> [die],[meisten].
det([most], [fem, pl,nom]) --> [die],[meisten].
det([most], [fem, pl,akk]) --> [die],[meisten].
 
det([many], [mask,pl,nom]) --> [viele].
det([many], [mask,pl,akk]) --> [viele].
det([many], [fem, pl,nom]) --> [viele].
det([many], [fem, pl,akk]) --> [viele].

det([def],[_Gen,pl,_Kas]) --> [Zahlatom],  
    { anzahl(Zahlatom,Zahl), Zahl >= 2 }.

anzahl(Atom,N) :-
    atom_codes(Atom,Codes),
    number_codes(1234567890,NumCodes),
    subset(Codes,NumCodes), % Atom ist Zahlatom
    number_codes(N,Codes).

pron([rel],[mask,sg,nom]) --> [der].
pron([rel],[mask,sg,gen]) --> [dessen].
pron([rel],[mask,sg,dat]) --> [dem].
pron([rel],[mask,sg,akk]) --> [den].

pron([rel],[fem, sg,nom]) --> [die].
pron([rel],[fem, sg,gen]) --> [derer].
pron([rel],[fem, sg,dat]) --> [der].
pron([rel],[fem, sg,akk]) --> [die].

pron([rel],[mask,pl,nom]) --> [die].
pron([rel],[mask,pl,gen]) --> [deren].
pron([rel],[mask,pl,dat]) --> [denen].
pron([rel],[mask,pl,akk]) --> [die].

pron([rel],[fem, pl,nom]) --> [die].
pron([rel],[fem, pl,gen]) --> [derer].
pron([rel],[fem, pl,dat]) --> [denen].
pron([rel],[fem, pl,akk]) --> [die].

pron([qu], [mask,sg,nom]) --> [wer].
pron([qu], [mask,sg,akk]) --> [wen].

pron([rezi],[mask,pl,akk]) --> [einander].
pron([refl],[mask,sg,akk]) --> [sich].
pron([refl],[mask,pl,akk]) --> [sich].

pron([per],[mask,sg,nom]) --> [er].
pron([per],[mask,sg,dat]) --> [ihm].
pron([per],[mask,sg,akk]) --> [ihn].

pron([per],[fem, sg,nom]) --> [sie].
pron([per],[fem, sg,dat]) --> [ihr].
pron([per],[fem, sg,akk]) --> [sie].

pron([per],[mask,pl,nom]) --> [sie].
pron([per],[mask,pl,dat]) --> [ihnen].
pron([per],[mask,pl,akk]) --> [sie].

pron([per],[fem, pl,nom]) --> [sie].
pron([per],[fem, pl,dat]) --> [ihnen].
pron([per],[fem, pl,akk]) --> [sie].

poss([def(mask,sg)],[mask,sg,nom]) --> [sein].
poss([def(mask,sg)],[fem, sg,nom]) --> [seine].
poss([def(mask,sg)],[mask,sg,akk]) --> [seinen].
poss([def(mask,sg)],[fem, sg,akk]) --> [seine].

poss([def(fem,sg)],[mask,sg,nom]) --> [ihr].
poss([def(fem,sg)],[fem, sg,nom]) --> [ihre].
poss([def(fem,sg)],[mask,sg,akk]) --> [ihren].
poss([def(fem,sg)],[fem, sg,akk]) --> [ihre].

poss([def(mask,sg)],[mask,pl,nom]) --> [seine].
poss([def(mask,sg)],[fem, pl,nom]) --> [seine].
poss([def(mask,sg)],[mask,pl,akk]) --> [seine].
poss([def(mask,sg)],[fem, pl,akk]) --> [seine].

poss([def(fem,sg)],[mask,pl,nom]) --> [ihre].
poss([def(fem,sg)],[fem, pl,nom]) --> [ihre].
poss([def(fem,sg)],[mask,pl,akk]) --> [ihre].
poss([def(fem,sg)],[fem, pl,akk]) --> [ihre].

poss([rel(mask,sg)],[-,sg,-]) --> [dessen].
poss([rel(mask,sg)],[-,pl,-]) --> [dessen].
poss([rel(fem, sg)],[-,sg,-]) --> [deren].
poss([rel(fem, sg)],[-,pl,-]) --> [deren].
poss([rel(mask,pl)],[-,sg,-]) --> [deren].
poss([rel(mask,pl)],[-,pl,-]) --> [deren].
poss([rel(fem, pl)],[-,sg,-]) --> [deren].
poss([rel(fem, pl)],[-,pl,-]) --> [deren].

poss([qu],[-,-,-]) --> [wessen]. % Defaultform, weniger Lesarten

det([more],[-,pl,-]) --> [mehr].

