showTree([Wurzel|Bs],Einrueckung) :-
    tab(Einrueckung), writeq(Wurzel),
    (Bs = [[Blatt]] -> tab(1), writeq(Blatt)
    ; Einrueckung2 is Einrueckung + 3,
        showTrees(Bs,Einrueckung2)).
showTree([],Einrueckung) :-
    tab(Einrueckung), writeq([]).

showTrees([Baum|Baeume],Einrueckung) :-
    nl,showTree(Baum,Einrueckung),
    showTrees(Baeume,Einrueckung).
showTrees([],_).

writeTrSem([Wurzel|Bs],Sem/2,Einrueckung) :-
    SemExists =.. [Sem,[Wurzel|Bs],_],
    SemBaum =.. [Sem,[Wurzel|Bs],SemTerm],
    ( SemExists % falls es eine Sem/2-Bedeutung gibt,
    ->  % schreibe alle Bedeutungen unter die Wurzel
        tab(Einrueckung),writeq(Wurzel),
        (Bs = [[Blatt]] -> tab(1),writeq(Blatt) ; true),
        (SemBaum, % berechne eine Bedeutung SemTerm
            (nl,tab(Einrueckung),write('+ '),writen(SemTerm)),
            fail ; true)
    ; tab(Einrueckung),writeq(Wurzel) ), % Wort ohne Bed.
    ( Bs = [[Blatt]] -> true % schon geschrieben
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsSem(Bs,Sem/2,Einrueckung2) ).
writeTrSem([],_Sem/2,Einrueckung) :-
    tab(Einrueckung), writeq([]).
    
writeTrsSem([Baum|Baeume],Sem/2,Einrueckung) :-
    nl,writeTrSem(Baum,Sem/2,Einrueckung),
    writeTrsSem(Baeume,Sem/2,Einrueckung).
writeTrsSem([],_/2,_).

writen(Term) :- \+ \+((numbervars(Term,23,_),
           write_term(Term,[numbervars(true)]))).

semTy([Wurzel|Bs],LamTermTy) :-
    sem([Wurzel|Bs],LamTerm),
    type(LamTerm,LamTermGetypt,Typ),
    LamTermTy = (LamTermGetypt:Typ).

writeTrSemTy([Wurzel|Bs],Sem/2,SemTy/2,Einrueckung) :-
    SemExists =.. [Sem,[Wurzel|Bs],_],
    SemBaum =.. [Sem,[Wurzel|Bs],SemTerm],
    SemTyExists =.. [SemTy,[Wurzel|Bs],_],
    SemTyBaum =.. [SemTy,[Wurzel|Bs],SemTyTerm],
    ( SemTyExists % falls es eine SemTy/2-Bedeutung gibt,
    ->  % schreibe alle Bedeutungen unter die Wurzel
        tab(Einrueckung),writeq(Wurzel),
        (Bs = [[Blatt]] -> tab(1),writeq(Blatt) ; true),
        (SemTyBaum,nl, % berechne eine SemTy/2-Bedeutung 
            tab(Einrueckung),write('+ '),writen(SemTyTerm),
            fail ; true)
    ; ( SemExists 
      -> tab(Einrueckung),writeq(Wurzel),
         (Bs = [[Blatt]] -> tab(1),writeq(Blatt) ; true),
         (SemBaum,nl, % berechne eine Sem/2-Bedeutung 
            tab(Einrueckung),write('- '),writen(SemTerm),
            fail ; true)
      ; tab(Einrueckung),writeq(Wurzel) % Wort ohne Bed.
      )
    ),
    ( Bs = [[Blatt]] -> true % schon geschrieben
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsSemTy(Bs,Sem/2,SemTy/2,Einrueckung2) ).
writeTrSemTy([],_Sem/2,_SemTy/2,Einrueckung) :-
    tab(Einrueckung), writeq([]).
    
writeTrsSemTy([Baum|Baeume],Sem/2,SemTy/2,Einrueckung) :-
    nl,writeTrSemTy(Baum,Sem/2,SemTy/2,Einrueckung),
    writeTrsSemTy(Baeume,Sem/2,SemTy/2,Einrueckung).
writeTrsSemTy([],_/2,_/2,_).

