:- style_check(-discontiguous).
:- [grammatik], 
   ['Semantik/lambdaTerme.pl','Semantik/sem.pl'].                         

parses :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    startsymbol(S),
    parse(S,Atomlist,Baum,ExpTerm),
    call(ExpTerm), write('Baum:   '),
    nl,writeTrSem(Baum,sem/2,4),nl, 
    fail.
parses.

:- ['Parser/dot.semantikbaum.pl'].

parsesd :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    setof(Baum,S^ExpTerm^(startsymbol(S),
                          parse(S,Atomlist,Baum,ExpTerm),
                          ExpTerm),
          Baeume),
    displaySemTrees(Baeume,sem/2).
parsesd.

parse(Startsymbol,Atomlist,Baum,ExpTerm) :-
    addTree:translate(Startsymbol,Term,[Baum]),
    addDifflists:translate(Term,ExpTerm,Atomlist,[]),
    nl,write('Aufruf: '), portray_clause(ExpTerm).

parses(Dateiname) :-   % Bedeutung für alle Ausdrücke in
   open(Dateiname,read,Strom),     % der Datei berechnen
   parses2(Strom),
   close(Strom), nl, write('Fertig.\n').
parses2(Strom) :-
   read_sentence(Strom, Satz, []),
   (Satz = [] -> true  % Dateiende 
   ; tokenize(Satz,Atome),nl,writeq(Atome),nl,
       (setof(Baum,tokenizer:parse(Atome,Baum),Trees)
       -> writeTrsSem(Trees,sem/2,3), nl
       ; nl, tab(3),
           write('* keine Analysen gefunden *'),nl),
       parses2(Strom)   % weitere Sätze
   ).

:- ['Semantik/type.pl'].
parsest :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    startsymbol(S),
    parse(S,Atomlist,Baum,ExpTerm),
    call(ExpTerm),write('Baum:   '),nl,
    % semTy(Baum,_), % unterdrückt untypisierbare
    writeTrSemTy(Baum,sem/2,semTy/2,4),nl,
    fail. 
parsest.

parsestd :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    setof(Baum,S^ExpTerm^(startsymbol(S),
                          parse(S,Atomlist,Baum,ExpTerm),
                          ExpTerm),
          Baeume),
    displaySemTyTrees(Baeume,sem/2,semTy/2).

parsest(Dateiname) :- % Typsemantik aller Sätze der Datei
   open(Dateiname,read,Strom),
   parsest2(Strom),
   close(Strom),nl,write('Fertig.\n').
parsest2(Strom) :-
   read_sentence(Strom, Satz, []),
   (Satz = [] -> true  % Dateiende 
   ; tokenize(Satz,Atome),
       nl,writeq(Atome),nl,
       (setof(Baum,tokenizer:parse(Atome,Baum),Trees)
       -> writeTrsSemTy(Trees,sem/2,semTy/2,3), nl
       ; nl, tab(3),
           write('* keine Analysen gefunden *'), nl),
       parsest2(Strom)   % weitere Sätze
   ).

:- ['Semantik/auswertung.pl'].

% Nur typisierbare Bedeutungen berücksichtigen:
semTy(Baum,LamTermTyped,Kontext) :-
    sem(Baum,LamTerm),
    free(LamTerm,Vars), mkContext(Vars,Kontext),
    type(Kontext,LamTerm,LamTermTyped,_Type).

frage :- write('Beende die Frage mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    Startsymbol = s([qu],[_Temp,ind,_Vst]),
    parse(Startsymbol,Atomlist,Baum,ExpTerm),
    (call(ExpTerm) ->
        (semTy(Baum,LamTermTy,Env) % erste typ.Bedeutung!
        -> (Env = [_|_] -> write('\nPronomen/freie Var in:\n'),
               portray_clause((Env :- LamTermTy))
           ; eval([],LamTermTy,Wert),
               nl,write('Antwort: '),write(Wert) )
        ; write('\nÜbersetzung Frage -> typ.Formel fehlt.'),
            nl,nl, writeTrSemTy(Baum,sem/2,semTy/2,4) )
    ; nl, write('\nEingabe syntaktisch nicht erkannt.\n')
    ).

